<?php // $Id: webform_pay.inc,v 1.1 2010/10/20 01:22:13 quicksketch Exp $

class webform_pay extends pay_form {
  var $min_amount = NULL;
  var $max_amount = NULL;
  var $embeddable = FALSE;

  /**
   * Override of pay_form::form().
   */
  function form(&$form, &$form_state) {
    // Call form_setup because we won't be calling parent::form.
    $this->form_setup($form, $form_state);

    $group = $this->handler();

    // Ensure there is a "total" field, but populate it on the validate hook.
    $form[$group]['total'] = array(
      '#type' => 'textfield',
      '#access' => FALSE,
    );

    $form[$group]['pay_method'] = $this->pay_method_form($form_state);
  }

  /**
   * Override of pay_form::form_alter().
   *
   * Prevent the normal form_altering behavior, which we don't need at all.
   */
  function form_alter(&$form, &$form_state) {
    // Intentionally empty.
  }

  /**
   * Override of pay_form::form_validate().
   */
  function form_validate($form, &$form_state) {
    $values = $this->form_values($form_state);

    // If there is no total value per payment method, set the global total.
    foreach ($values['pay_method']['selected'] as $pmid => $status) {
      if (!$status) continue;
      $key = $this->handler();
      $method_values = $form_state['values'][$key]['pay_method'][$pmid];
      $method_element = $form[$key]['pay_method'][$pmid];
      if (!$method_values['total']) {
        form_set_value($method_element['total'], $values['total'], $form_state);
        $method_values['total'] = $values['total'];
      }
      $pay_method = pay_method_load($method_values);
      $pay_method->pay_method_validate($form, $form_state, $method_element);
    }
  }
}

